
%define lib_major	2
%define lib_name_orig	%{package_prefix}%mklibname binutils
%define lib_name	%{lib_name_orig}%{lib_major}
%define	dev_name	%mklibname binutils -d

# Allow SPU support for native PowerPC arches, not cross env packages
%define spu_arches	ppc ppc64

# Define if building a cross-binutils
%define build_cross	0
%{expand: %{?cross:	%%global build_cross 1}}

%if %{build_cross}
%define target_cpu	%{cross}
%define target_platform	%{target_cpu}-linux
%if "%{target_cpu}" == "spu"
%define target_platform	%{target_cpu}-unknown-elf
%endif
%define program_prefix	%{target_platform}-
%define package_prefix	cross-%{target_cpu}-
%else
%define target_cpu	%{_target_cpu}
%define target_platform	%{_target_platform}
%define program_prefix	%{nil}
%define package_prefix	%{nil}
%endif

%define arch		%(echo %{target_cpu}|sed -e "s/\(i.86\|athlon\)/i386/" -e "s/amd64/x86_64/" -e "s/\(sun4.*\|sparcv[89]\)/sparc/")
%define isarch()	%(case %{arch} in (%1) echo 1;; (*) echo 0;; esac)

# List of targets where gold can be enabled
%define gold_arches %(echo %{ix86} x86_64 ppc ppc64 %{sparc} %{arm}|sed 's/[ ]/\|/g')

%define gold_default	1

Summary:	GNU Binary Utility Development Utilities
Name:		%{package_prefix}binutils
Version:	2.23.51.0.3
Release:	3
License:	GPLv3+
Group:		Development/Other
URL:		http://sources.redhat.com/binutils/
# official beta snapshot from http://git.kernel.org/?p=linux/kernel/git/hjl/binutils.git;a=summary
Source0:	http://ftp.kernel.org/pub/linux/devel/binutils/binutils-%{version}.tar.xz
#Source1:	http://ftp.kernel.org/pub/linux/devel/binutils/binutils-%{version}.tar.bz2.sign
Source2:	build_cross_binutils.sh
Source3:	spu_ovl.o
Source4:	embedspu.sh
Source5:	binutils-2.19.50.0.1-output-format.sed
Source10:	binutils.rpmlintrc
%if "%{name}" == "binutils"
%rename		%{lib_name}
%endif
Conflicts:	gcc-c++ < 3.2.3-1mdk
BuildRequires:	autoconf automake bison flex gcc gettext texinfo
BuildRequires:	dejagnu zlib-devel
# make check'ing requires libdl.a
BuildRequires:	glibc-static-devel >= 6:2.14.90-8
# gold make check'ing requires libstdc++.a & bc
BuildRequires:	libstdc++-static-devel bc

# Fedora patches:
Patch01:	binutils-2.20.51.0.2-libtool-lib64.patch
Patch02:	binutils-2.23.51.0.2-ppc64-pie.patch
Patch03:	binutils-2.20.51.0.2-ia64-lib64.patch
# We don't want this one!
#Patch04:	binutils-2.20.51.0.2-version.patch
Patch05:	binutils-2.20.51.0.2-set-long-long.patch
Patch06:	binutils-2.20.51.0.10-copy-osabi.patch
Patch07:	binutils-2.20.51.0.10-sec-merge-emit.patch
# we already set our own set of defaults...
# Enable -zrelro by default: BZ #621983
#Patch08:	binutils-2.22.52.0.1-relro-on-by-default.patch
# Local patch - export demangle.h with the binutils-devel rpm.
Patch09:	binutils-2.22.52.0.1-export-demangle.h.patch
# Disable checks that config.h has been included before system headers.  BZ #845084
Patch10:	binutils-2.22.52.0.4-no-config-h-check.patch

# Mandriva patches
# (from gb, proyvind): defaults to i386 on x86_64 or ppc on ppc64 if 32 bit personality is set
Patch21:	binutils-2.22.52.0.4-linux32.patch
# (proyvind): skip gold tests that fails
Patch27:	binutils-2.21.51.0.8-skip-gold-check.patch
Patch28:	binutils-2.21.51.0.8-ld-default-settings.patch
# enables the following by default:
# --as-needed
# --hash-style=gnu
# --enable-new-dtags
# --no-undefined
# -O1
# --threads
# --warn-common
# --warn-execstack
# --warn-shared-textrel
# --warn-unresolved-symbols
# -z relro
# --build-id=sha1
# --icf=safe
Patch29:	binutils-2.21.52.0.2-ld.gold-default-settings.patch
#from Леонид Юрьев leo@yuriev.ru, posted to binutils list
Patch31:	binutils-2.22.51.0.1-fix-overrides-for-gold-testsuite.patch
Patch33:	binutils-2.21.53.0.1-ld_13048-Invalid-address-for-x32.patch
# from upstream
Patch34:	binutils-2.21.53.0.3-opcodes-missing-ifdef-enable-nls.patch

%description
Binutils is a collection of binary utilities, including:

   * ar: creating modifying and extracting from archives
   * nm: for listing symbols from object files
   * objcopy: for copying and translating object files
   * objdump: for displaying information from object files
   * ranlib: for generating an index for the contents of an archive
   * size: for listing the section sizes of an object or archive file
   * strings: for listing printable strings from files
   * strip: for discarding symbols (a filter for demangling encoded C++ symbols
   * addr2line: for converting addresses to file and line
   * nlmconv: for converting object code into an NLM

Install binutils if you need to perform any of these types of actions on
binary files.  Most programmers will want to install binutils.

%ifarch %{spu_arches}
%package -n	spu-binutils
Summary:	GNU Binary Utility Development Utilities for Cell SPU
Group:		Development/Other

%description -n	spu-binutils
This package contains the binutils with Cell SPU support.
%endif

%package -n	%{dev_name}
Summary:	Main library for %{name}
Group:		Development/Other
Provides:	%{name}-devel = %{version}-%{release}
Provides:	%{lib_name}-devel = %{version}-%{release}
Obsoletes:	%{lib_name}-devel
Requires:	zlib-devel

%description -n	%{dev_name}
This package contains BFD and opcodes static libraries and associated
header files.  Only *.a libraries are included, because BFD doesn't
have a stable ABI.  Developers starting new projects are strongly encouraged
to consider using libelf instead of BFD.

%prep
%setup -q -n binutils-%{version}
%patch01 -p0 -b .libtool-lib64~
# Needs porting, and we don't care about the target for now
#patch02 -p1 -b .ppc64-pie~
%ifarch ia64
%if "%{_lib}" == "lib64"
%patch03 -p0 -b .ia64-lib64~
%endif
%endif
#patch04 -p0 -b .version~
%patch05 -p0 -b .set-long-long~
%patch06 -p0 -b .copy-osabi~
%patch07 -p0 -b .sec-merge-emit~
#patch08 -p0 -b .relro~
%patch09 -p0 -b .export-demangle-h~
%patch10 -p0 -b .no-config-h-check~
 
%patch21 -p1 -b .linux32~
#patch27 -p1 -b .skip_gold_check~
# Modify the defaults of the BFD linker as well, since many
# things fall back to it...
%patch28 -p1 -b .defaults~
%patch29 -p1 -b .gold_defaults~
%patch31 -p1 -b .gold_testsuite~
# later
#%%patch33 -p1 -b .ld_13048~
%patch34 -p1 -b .nls~
# for boostrapping, can be rebuilt afterwards in --enable-maintainer-mode
cp %{SOURCE3} ld/emultempl/

%build
# Additional targets
ADDITIONAL_TARGETS=""
case %{target_cpu} in
ppc | powerpc)
  ADDITIONAL_TARGETS="powerpc64-%{_target_vendor}-%{_target_os}"
  ;;
ppc64)
  ADDITIONAL_TARGETS=""
  ;;
ia64)
  ADDITIONAL_TARGETS="i586-%{_target_vendor}-%{_target_os}"
  ;;
i*86 | athlon*)
  ADDITIONAL_TARGETS="x86_64-%{_target_vendor}-%{_target_os}"
  ;;
sparc*)
  ADDITIONAL_TARGETS="sparc64-%{_target_vendor}-%{_target_os}"
  ;;
mipsel)
  ADDITIONAL_TARGETS="mips64el-%{_target_vendor}-%{_target_os}"
  ;;
mips)
  ADDITIONAL_TARGETS="mips64-%{_target_vendor}-%{_target_os}"
  ;;
esac
%ifarch %{spu_arches}
if [[ -n "$ADDITIONAL_TARGETS" ]]; then
  ADDITIONAL_TARGETS="$ADDITIONAL_TARGETS,spu-unknown-elf"
else
  ADDITIONAL_TARGETS="spu-unknown-elf"
fi
%endif
if [[ -n "$ADDITIONAL_TARGETS" ]]; then
  TARGET_CONFIG="$TARGET_CONFIG --enable-targets=$ADDITIONAL_TARGETS"
fi

case %{target_cpu} in
ppc | powerpc | i*86 | athlon* | sparc* | mips* | s390* | sh* | arm*)
  TARGET_CONFIG="$TARGET_CONFIG --enable-64-bit-bfd"
  ;;
esac

%if "%{name}" != "binutils"
%define _program_prefix %{program_prefix}
TARGET_CONFIG="$TARGET_CONFIG --target=%{target_platform}"
%endif

# Don't build shared libraries in cross binutils
%if "%{name}" == "binutils"
TARGET_CONFIG="$TARGET_CONFIG --enable-shared --with-pic"
%endif

# Binutils comes with its own custom libtool
# [gb] FIXME: but system libtool also works and has relink fix
%define __libtoolize /bin/true

# Build main binaries
rm -rf objs
mkdir objs
pushd objs
CONFIGURE_TOP=.. %configure2_5x $TARGET_CONFIG	--with-bugurl=http://qa.mandriva.com/ \
%if %{gold_default}
						--enable-ld=yes \
						--enable-gold=default \
%else
						--enable-ld=default \
						--enable-gold=yes \
%endif
						--enable-plugins \
						--enable-threads \
%if "%{_lib}" == "lib64"
						--with-lib-path=/%{_lib}:%{_libdir}:%{_prefix}/local/%{_lib}:/lib:%{_prefix}/lib:%{_prefix}/local/lib \
%else
						--with-lib-path=/lib:%{_prefix}/lib:%{_prefix}/local/lib \
%endif
%ifarch armv7l armv7hl
						--with-cpu=cortex-a8 \
						--with-tune=cortex-a8 \
						--with-arch=armv7-a \
						--with-mode=thumb \
%ifarch armv7l
						--with-float=softfp \
%else
						--with-float=hard \
%endif
						--with-fpu=vfpv3-d16 \
						--with-abi=aapcs-linux \
%endif
						--disable-werror \
						--with-separate-debug-dir=%{_prefix}/lib/debug
# There seems to be some problems with builds of gold randomly failing whenever
# going through the build system, so let's try workaround this by trying to do
# make once again when it happens...
%make tooldir=%{_prefix} || make tooldir=%{_prefix}
make -C bfd/doc html
mkdir -p ../html
cp -f bfd/doc/bfd.html/* ../html
popd

# Build alternate binaries (spu-gas in particular)
case "$ADDITIONAL_TARGETS," in
%ifarch %{spu_arches}
*spu-*-elf,*)
  ALTERNATE_TARGETS="spu-unknown-elf"
  ;;
%endif
*)
  ;;
esac
if [[ -n "$ALTERNATE_TARGETS" ]]; then
  for target in $ALTERNATE_TARGETS; do
    cpu=`echo "$target" | sed -e "s/-.*//"`
    rm -rf objs-$cpu
    mkdir objs-$cpu
    pushd objs-$cpu
    CONFIGURE_TOP=.. %configure	--enable-shared \
				--target=$target \
				--program-prefix=$cpu- \
%if "%{distepoch}" < "2012"
				--enable-ld=default \
				--enable-gold=yes \
%else
				--enable-ld=yes \
				--enable-gold=default \
%endif
				--disable-werror \
				--with-bugurl=http://qa.mandriva.com/
    # make sure we use the fully built libbfd & libopcodes libs
    # XXX could have been simpler to just pass $ADDITIONAL_TARGETS
    # again to configure and rebuild all of those though...
    for dso in bfd opcodes; do
    %make all-$dso
    rm -f $dso/.libs/lib$dso-%{version}.so
    ln -s ../../../objs/$dso/.libs/lib$dso-%{version}.so $dso/.libs/
    done
    %make all-binutils all-gas all-ld
    popd
  done
fi

%check
# All Tests must pass on x86 and x86_64
echo ====================TESTING=========================
# workaround for not using colorgcc when building due to colorgcc
# messes up output redirection..
PATH=${PATH#%{_datadir}/colorgcc:}
%if %isarch i386|x86_64|ppc|ppc64|spu
%make -k -C objs check CFLAGS="" CXXFLAGS="" LDFLAGS="" || :
[[ -d objs-spu ]] && \
%make -C objs-spu check-gas CFLAGS="" CXXFLAGS="" LDFLAGS=""
%else
%make -C objs -k check CFLAGS="" CXXFLAGS="" LDFLAGS="" || echo make check failed
%endif
echo ====================TESTING END=====================

logfile="%{name}-%{version}-%{release}.log"
rm -f $logfile; find . -name "*.sum" | xargs cat >> $logfile

%install
mkdir -p %{buildroot}%{_prefix}
%makeinstall_std -C objs

rm -f %{buildroot}%{_mandir}/man1/{dlltool,nlmconv,windres}*
rm -f %{buildroot}%{_infodir}/dir
rm -f %{buildroot}%{_libdir}/*.la
rm -f %{buildroot}%{_libdir}/lib{bfd,opcodes}.so

%if "%{name}" == "binutils"
make -C objs prefix=%{buildroot}%{_prefix} infodir=%{buildroot}%{_infodir} install-info
install -m 644 include/libiberty.h %{buildroot}%{_includedir}/
if [ -e objs/libiberty/pic/libiberty.a ]; then
	# Ship with the PIC libiberty
	install -m 644 objs/libiberty/pic/libiberty.a %{buildroot}%{_libdir}/
else
	install -m 644 objs/libiberty/libiberty.a %{buildroot}%{_libdir}/
fi
rm -rf %{buildroot}%{_prefix}/%{_target_platform}/

# Sanity check --enable-64-bit-bfd really works.
grep '^#define BFD_ARCH_SIZE 64$' %{buildroot}%{_prefix}/include/bfd.h
# Fix multilib conflicts of generated values by __WORDSIZE-based expressions.
%ifarch %{ix86} x86_64 ppc ppc64 s390 s390x sh3 sh4 sparc sparc64 %arm
sed -i -e '/^#include "ansidecl.h"/{p;s~^.*$~#include <bits/wordsize.h>~;}' \
    -e 's/^#define BFD_DEFAULT_TARGET_SIZE \(32\|64\) *$/#define BFD_DEFAULT_TARGET_SIZE __WORDSIZE/' \
    -e 's/^#define BFD_HOST_64BIT_LONG [01] *$/#define BFD_HOST_64BIT_LONG (__WORDSIZE == 64)/' \
    -e 's/^#define BFD_HOST_64_BIT \(long \)\?long *$/#if __WORDSIZE == 32\
#define BFD_HOST_64_BIT long long\
#else\
#define BFD_HOST_64_BIT long\
#endif/' \
    -e 's/^#define BFD_HOST_U_64_BIT unsigned \(long \)\?long *$/#define BFD_HOST_U_64_BIT unsigned BFD_HOST_64_BIT/' \
    %{buildroot}%{_prefix}/include/bfd.h
%endif
touch -r bfd/bfd-in2.h %{buildroot}%{_prefix}/include/bfd.h

# Generate .so linker scripts for dependencies; imported from glibc/Makerules:

# This fragment of linker script gives the OUTPUT_FORMAT statement
# for the configuration we are building.
OUTPUT_FORMAT="\
/* Ensure this .so library will not be used by a link for a different format
   on a multi-architecture system.  */
$(gcc $CFLAGS $LDFLAGS -shared -x c /dev/null -o /dev/null -Wl,--verbose -v 2>&1 | sed -n -f "%{SOURCE5}")"

tee %{buildroot}%{_libdir}/libbfd.so <<EOH
/* GNU ld script */

$OUTPUT_FORMAT

/* The libz dependency is unexpected by legacy build scripts.  */
INPUT ( %{_libdir}/libbfd.a -liberty -lz )
EOH

tee %{buildroot}%{_libdir}/libopcodes.so <<EOH
/* GNU ld script */

$OUTPUT_FORMAT

INPUT ( %{_libdir}/libopcodes.a -lbfd -lz )
EOH

# Symlinks for compatibility with crosscompilers
cd %buildroot%_bindir
for i in *; do
	ln -s $i %_target_platform-$i
done
cd -

%else
rm -f  %{buildroot}%{_libdir}/libiberty.a
rm -rf %{buildroot}%{_infodir}
rm -rf %{buildroot}%{_datadir}/locale/
rm -f  %{buildroot}%{_prefix}/%{_target_platform}/%{target_cpu}-linux/lib/*.la
%endif

%if "%{name}" == "binutils"
%find_lang binutils --all-name
%endif

# Alternate binaries
[[ -d objs-spu ]] && {
destdir=`mktemp -d`
make -C objs-spu DESTDIR=$destdir install-binutils install-gas install-ld
mv $destdir%{_bindir}/spu-* %{buildroot}%{_bindir}/
mkdir -p %{buildroot}%{_prefix}/spu/bin
mv $destdir%{_prefix}/spu-unknown-elf/bin/* %{buildroot}%{_prefix}/spu/bin/
rm -rf $destdir
cat > %{buildroot}%{_bindir}/ppu-as << EOF
#!/bin/sh
exec %{_bindir}/as -mcell -maltivec \${1+"\$@"}
EOF
chmod +x %{buildroot}%{_bindir}/ppu-as
install -m 755 %{SOURCE4} %{buildroot}%{_bindir}/embedspu
}

%if "%{name}" == "binutils"
%files -f binutils.lang
%else
%files
%endif
%{_bindir}/*addr2line
%{_bindir}/*ar
%{_bindir}/*as
%{_bindir}/*c++filt
%{_bindir}/*elfedit
%{_bindir}/*gprof
%{_bindir}/*ld
%{_bindir}/*ld.bfd
%{_bindir}/*nm
%{_bindir}/*objcopy
%{_bindir}/*objdump
%{_bindir}/*ranlib
%{_bindir}/*readelf
%{_bindir}/*size
%{_bindir}/*strings
%{_bindir}/*strip
%ifarch %{spu_arches}
%{_bindir}/ppu-as
%endif
%{_mandir}/man1/*
%if "%{name}" == "binutils"
%{_infodir}/*info*
%{_libdir}/libbfd-%{version}*.so
%{_libdir}/libopcodes-%{version}*.so
%else
%{_prefix}/%{target_platform}/bin/*
%{_prefix}/%{target_platform}/lib/ldscripts
%endif

%ifarch %{spu_arches}
%files -n spu-binutils
%{_bindir}/spu-*
%{_bindir}/embedspu
%dir %{_prefix}/spu/bin
%{_prefix}/spu/bin
%endif

%if "%{name}" == "binutils"
%files -n %{dev_name}
%doc html
%{_includedir}/*.h
%{_libdir}/libbfd.a
%{_libdir}/libbfd.so
%{_libdir}/libopcodes.a
%{_libdir}/libopcodes.so
%{_libdir}/libiberty.a
%endif


%changelog
* Thu Oct 04 2012 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.23.51.0.3-3
+ Revision: 818408
- revert change to bfd linker as default and introduction of alternatives for
  linker

* Fri Sep 28 2012 Paulo Andrade <pcpa@mandriva.com.br> 2.23.51.0.3-2
+ Revision: 817824
- Use ld.bdf by default.
- Use alternatives to allow changing default linker.
- Setup package to default to ld.bfd if installed with --noscripts.

* Wed Sep 19 2012 Bernhard Rosenkraenzer <bero@bero.eu> 2.23.51.0.3-1
+ Revision: 817113
- 2.23.51.0.3

* Wed Sep 12 2012 Bernhard Rosenkraenzer <bero@bero.eu> 2.23.51.0.2-1
+ Revision: 816863
- Add compat symlinks for crosscompiler toolchains
- Update to 2.23.51.0.2

  + Per Øyvind Karlsen <peroyvind@mandriva.org>
    - new version synced from rawhide

* Fri Jun 22 2012 Bernhard Rosenkraenzer <bero@bero.eu> 2.22.52.0.4-3
+ Revision: 806689
- Make the conflict between --icf, --gc-sections and -r soft

* Thu Jun 14 2012 Bernhard Rosenkraenzer <bero@bero.eu> 2.22.52.0.4-2
+ Revision: 805741
- Make gold the default linker

* Thu Jun 07 2012 Bernhard Rosenkraenzer <bero@bero.eu> 2.22.52.0.4-1
+ Revision: 803140
- Update to 2.22.52.0.4

* Fri May 11 2012 Bernhard Rosenkraenzer <bero@bero.eu> 2.22.52.0.3-2
+ Revision: 798231
- Add --icf=safe to gold default options

* Tue May 08 2012 Bernhard Rosenkraenzer <bero@bero.eu> 2.22.52.0.3-1
+ Revision: 797608
- Update to 2.22.52.0.3

* Sat Mar 31 2012 Bernhard Rosenkraenzer <bero@bero.eu> 2.22.52.0.1-2
+ Revision: 788413
- Fix rpmlint badness 774

* Wed Feb 08 2012 Bernhard Rosenkraenzer <bero@bero.eu> 2.22.52.0.1-1
+ Revision: 772111
- Update to 2.22.52.0.1
- Add rpmlintrc file to prevent it from thinking binutils is a
  library package (libbfd*.so, libiberty*.so)

  + Per Øyvind Karlsen <peroyvind@mandriva.org>
    - Fix bug in GOLD sources parsing signed integers in command line options.
    - Add casts for building gold with 4.7 version of gcc. (P9 from Fedora)
    - fix %%find_lang to work with cross-build
    - pass '--all-name' to %%find_lang in stead to grab all locale files in one run
    - drop dependency on self
    - use %%rename
    - rediff and reenable patch to make regression tests pass with gold linker having
      modified defaults

* Sun Dec 11 2011 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.22.51.0.1-1
+ Revision: 740154
- do a better workaround for not using colorgcc in %%check
- drop ld-selective45-x86_64-xfail as it's no more needed
- drop old mips patches
- switch to official 2.22.51.0.1 release rather than using cvs snapshot

* Sat Nov 26 2011 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.22.51-3
+ Revision: 733548
- add a version buildrequires on glibc-static-devel to ensure that we get
  no-broken version
- update to latest snapshot
- drop P30 & P35 (fixed upstream)

  + Paulo Andrade <pcpa@mandriva.com.br>
    - Update for armv7hl Mandriva bootstrap.

* Fri Oct 07 2011 Paulo Andrade <pcpa@mandriva.com.br> 2.22.51-2
+ Revision: 703525
- Add correction to ld pr 13195 required to build chromium-browser

* Mon Sep 26 2011 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.22.51-1
+ Revision: 701234
- new version
- remove obsolete rpm stuff

  + Paulo Andrade <pcpa@mandriva.com.br>
    - Add default armv7 options

* Wed Sep 07 2011 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.21.53.0.2-2
+ Revision: 698649
- fix path to debug dir (#64200, from alissy)

* Fri Sep 02 2011 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.21.53.0.2-1
+ Revision: 697766
- enable NLS properly for opcodes (P34, from upstream)
- new version

* Thu Aug 11 2011 Paulo Andrade <pcpa@mandriva.com.br> 2.21.53.0.1-3
+ Revision: 693906
- Revert to use bfd linker due to x86_64 multilib and ix86 glibc problems

* Wed Aug 03 2011 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.21.53.0.1-2
+ Revision: 693092
- apply a couple of upstream patches..
- Update libiberty demangling.  (rhbz#727453, P10 from Fedora)
- Import Jakub Jelinek's patch to add support for displaying the contents of
  .debug_macro sections. (P9, from Fedora)

* Tue Jul 26 2011 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.21.53.0.1-1
+ Revision: 691808
- don't enable --no-undefined by default for gold linker just yet..
- new version
- add --with-lib-path support for GOLD as well
- new version snapshot
- fix defaults for gold linker
- fix regression tests to pass with new linker defaults
- enable various linker options by default for gold (P29)
- add workaround for test suite with colorgcc output redirection b0rkage
- add bc as buildrequires as it's required by gold test suite
- enable gold as default linker
- don't build check suite with our defailt %%{optflags}, it'll break it...
- set library search path with --with-lib-path (only for bfd linker for now)

* Thu Jul 14 2011 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.21.52.0.2-3
+ Revision: 689944
- add /usr/local/lib & all regular lib64 paths to gold library search path (30)

* Mon Jul 11 2011 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.21.52.0.2-1
+ Revision: 689555
- add source signature
- new version (with some contributions from Matthew Dawkins)

* Thu Jun 02 2011 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.21.51.0.9-2
+ Revision: 682490
- Properly warn relocation in readonly section in a shared object (P100)

* Wed May 25 2011 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.21.51.0.9-1
+ Revision: 679067
--enable-64-bit-bfd for s390*, sh* & arm*
- add arm* to bfd checks
- enable multithreading support for gold linker
- new version

* Tue May 10 2011 Antoine Ginies <aginies@mandriva.com> 2.21.51.0.8-4
+ Revision: 673299
- disable ld-default-setting changement just before an rc

* Thu May 05 2011 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.21.51.0.8-3
+ Revision: 668120
- copy "sha1" for build-id on heap so free() won't get fucked

* Thu May 05 2011 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.21.51.0.8-2
+ Revision: 667645
- enable various linker options by default
- new version
- build with bfd html docs, shipped with -devel package

  + Oden Eriksson <oeriksson@mandriva.com>
    - mass rebuild

* Wed Mar 02 2011 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.21.51.0.6-2
+ Revision: 641294
- revert accidental change of using gold as default linker (#62621)

* Thu Feb 24 2011 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.21.51.0.6-1
+ Revision: 639622
- sync patches with 2.21.51.0.6-1 from fedora
- clean up and simplify linux32 patch for easier maintenance

* Mon Sep 27 2010 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.20.51.0.11-1mnb2
+ Revision: 581171
- don't include in 'check' target (P27), require all other tests but gold to pass
- allow ld selective[45] tests to fail on x86_64 (P26)
- sync with 2.20.51.0.11-1 from fedora

* Wed Aug 11 2010 Pascal Terjan <pterjan@mandriva.org> 2.20.51.0.7-4mnb2
+ Revision: 569137
- Fix linking to bfd

  + Christophe Fergeau <cfergeau@mandriva.com>
    - remove ugly hack now that binutils rebuilt with the right default linker

* Tue Apr 27 2010 Pascal Terjan <pterjan@mandriva.org> 2.20.51.0.7-3mnb2
+ Revision: 539886
- Ugly workaround to build when gold is default

  + Christophe Fergeau <cfergeau@mandriva.com>
    - don't use gold by default

* Tue Apr 27 2010 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.20.51.0.7-1mnb2
+ Revision: 539422
- be lazy and don't bail out on test failures (due to gold test suite headaches)
- sync with 2.20.51.0.7-2 from fedora

* Mon Dec 28 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 2.20.51.0.4-2mnb2
+ Revision: 483152
- Fix build with targets which don't have/enable gold.
- Fix build when making cross-* binutils (explicit setup -n to rpmbuild)
- Ship ldscripts with cross-* binutils, some targets need it (like avr).

* Mon Dec 28 2009 Pascal Terjan <pterjan@mandriva.org> 2.20.51.0.4-1mnb2
+ Revision: 483127
- from Frederik Himpe
 o Update to new version 2.20.51.0.4 (fixes statically linking with STT_GNU_IFUNC symbols)
 o Sync patches with Fedora
 o Remove patches integrated upstream
 o Use %%configure2_5x macro instead of %%configure to fix warning when running ./configure

* Fri Nov 27 2009 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.20.51-3mnb2
+ Revision: 470603
- try work around build issues with gold on the BS by doing make again with just
  one job when build fails
- don't explicitly link against libc in linker script, it's implied by libz
- fix multilib conflict in bfd.h header rather than using multiarch
- add a linker script to cure any remaining issues with linking against libbfd

* Wed Nov 25 2009 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.20.51-2mnb2
+ Revision: 470096
- clear LDFLAGS when building test suite, otherwise some tests will fail
- skip tls_shared_gnu2_test that's known to fail (P28)
- add libstdc++-static-devel to buildrequires as it's required gold's test suite
- be sure to disable -Werror for main binaries as well
- add missing libdl dependency required by 'incremental_dump' (P27)
- add missing 'bfd_plugin_bfd_copy_link_hash_symbol_type' define (P26)
- enable plugins support
- enable gold in parallel with bfd linker (P40)

* Wed Nov 25 2009 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.20.51-1mnb2
+ Revision: 470017
- for teuf: 2.20.51 ;)
- regenerate patches
- specify http://qa.mandriva.com/ as url for bug reports

* Wed Nov 25 2009 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.19.51.0.14-5mnb2
+ Revision: 469897
- add dependency on zlib-devel for devel package

* Tue Nov 24 2009 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.19.51.0.14-4mnb2
+ Revision: 469861
- build with -fPIC to allow shared libraries to statically link against libbfd.a

* Tue Nov 24 2009 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.19.51.0.14-3mnb2
+ Revision: 469810
- add back and fix x86 part of linux32 patch that were silently dropped previously

* Tue Nov 24 2009 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.19.51.0.14-2mnb2
+ Revision: 469709
- don't override %%setup default directory
- fix headers being included more than once
- drop library package due to lack of stable ABI and drop .so symlinks to prevent
  dynamic linking/enforce static linking
- drop conditional scriptlet, we're never gonna backport binutils anyways...
- drop useless README
- disable -Werror through configure option rather than passing -Wno-error ourself

* Mon Nov 23 2009 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.19.51.0.14-1mnb2
+ Revision: 469382
- use multiarch to avoid conflict between 32 & 64 bit -devel packages (#55831)
- sync with binutils-2.19.51.0.14-34.fc12
- regenerate Mandriva patches (from Matthew Dawkins / Unity Linux)
- don't ship with PIC libiberty for mips..
- add missing 'OPTION_FIX_GS2F_KERNEL' enum type in binutils-2.19.51.0.2-mips-ls2f_fetch_fix.patch

* Wed Feb 11 2009 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.19.51.0.2-1mnb2
+ Revision: 339335
- apply mips patches from 2008.1 Gdium tree
- enable 64 bit support for mipsel
- new release: 2.19.51.0.2
- spec cosmetics
- remove locale files when doing cross build
- fix string literal errors when building binutils for mips

* Wed Dec 24 2008 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.19.50.0.1-1mnb2
+ Revision: 318384
- fix buildrequires
- sync with 2.19.50.0.1-8.fc11
- new release
- sync with binutils-2.18.50.0.9-1.fc10

* Mon Aug 18 2008 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.18.50.0.8-1mnb2
+ Revision: 273254
- new release
- sync with binutils-2.18.50.0.8-2.fc10

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Sun May 25 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 2.18.50.0.6-1mnb2
+ Revision: 211109
- Updated to version 2.18.50.0.6
- Changed license tag (GPL -> GPLv3+, following policy).
- Sync patches with Fedora.

* Mon Feb 18 2008 Thierry Vignaud <tv@mandriva.org> 2.18.50.0.3-1mnb1
+ Revision: 170649
- replace %%mkrel with %%manbo_mkrel for Manbo Core 1

* Thu Jan 31 2008 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.18.50.0.3-1mdv2008.1
+ Revision: 160824
- New release: 2.18.50.3
- sync patches with Fedora
- regenerate P21 (linux32)
- don't hardcode vendor name & os in target
- add translations
- cosmetics
- add missing ia64 patch from fedora
- sync with fedora 2.17.50.0.12-4
- move checks to %%check
- s/mandrake/mandriva/

  + Thierry Vignaud <tv@mandriva.org>
    - rebuild
    - kill re-definition of %%buildroot on Pixel's request
    - kill file require on info-install

  + Olivier Blin <blino@mandriva.org>
    - restore BuildRoot

  + Pixel <pixel@mandriva.com>
    - fix group (#28151)

* Sun May 06 2007 Christiaan Welvaart <spturtle@mandriva.org> 2.17.50.0.9-2mdv2008.0
+ Revision: 23749
- match all sparc flavors when checking target_cpu
- fix check to build alternate binaries for spu


* Tue Jan 09 2007 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.17.50.0.9-1mdv2007.0
+ Revision: 106684
- 2.17.50.0.9
- add embedspu to combine spu objects into normal executables for cell

* Wed Jan 03 2007 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.17.50.0.8-1mdv2007.1
+ Revision: 103768
- 2.17.50.0.8
- fix gas error on valid-code complaining about missing .cfi_endproc (BZ#3607)
- re-organise generation of cross binutils, enable make check for cross tools
- move cell spu bits to a specific sub package, don't build spu for cross ppc

* Tue Dec 19 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.16.91.0.7-6mdv2007.1
+ Revision: 99715
- integrate binart spu_ovl.o for bootstrap
- backport Cell SPU support
- reorganize targets selection, drop support for mach-o objects
- backport DT_GNU_HASH support
- make linux32 as generate 32-bit code on ppc64
- bunzip2 patches
- Import binutils

* Wed Oct 25 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.16.91.0.7-5mdv
- improve biarch x86-linux support (64-bit on 32-bit)
- update to upstream cell patch (new AltiVec instructions)

* Fri Sep 22 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.16.91.0.7-4mdv
- add cell ppu support

* Wed Aug 30 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.16.91.0.7-3mdv2007.0
- CVE-2006-2362 (PR binutils/2584)

* Fri Jul 21 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.16.91.0.7-2mdk
- build with -Wno-error
- more libtool fixes for build
- selected fixes from CVS:
  * add "nop memory" for i386/x86-64
  * fix x86-64 disassembler for sidt/sgdt
  * fix a visibility bug in ELF linker (PR 2884)

* Fri May 12 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.16.91.0.7-1mdk
- 2.16.91.0.7
- fix build with gcc4.1

* Fri May 12 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.16.91.0.6-2mdk
- avoid abort with dynamic symbols in >64K sections (PR 2411)
- merge with RH 2.16.91.0.6-6
  * support S signal frame augmentation flag in .eh_frame,
    add .cfi_signal_frame support (#175951, PR other/26208, BZ#300)
  * support DW_CFA_val_{offset,offset_sf,expression} in readelf/objdump
  * fix relaxation of TLS GD to LE on PPC (RH #184590)
  * fix for g++ -frepo ((RH #187142)

* Tue Mar 07 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.16.91.0.6-1mdk
- 2.16.91.0.6
- fix PR ld/2218 (H.J. Lu)
- add Merom New Instructions (MNI)

* Sat Aug 13 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.16.91.0.2-3mdk
- fix requires for install-info

* Fri Aug 05 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.16.91.0.2-2mdk
- remove obsolete patch that was fixed in a previous snapshot
- make the linker ignore .got2 relocs against symbols from discarded
  sections (Alan Modra, PR target/17828)

* Sat Jul 23 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.16.91.0.2-1mdk
- 2.16.91.0.2:
  * update from binutils 2005 0720
  * add AMD SVME & Intel VMX support
  * add x86-64 new relocations for medium model
  * fix a PIE regression (PR 975)
  * fix an x86_64 signed 32bit displacement regression
  * fix PPC PLT (PR 1004)
  * imrove empty section removal

* Fri Jul 08 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.16.91.0.1-1mdk
- 2.16.91.0.1

* Thu Jun 16 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.16.90.0.3-2mdk
- all tests pass on ppc64 too
- build sparc with --enable-64-bit-bfd (peroyvind)

* Wed May 18 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.16.90.0.3-1mdk
- 2.16.90.0.3

* Sat May 07 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.16.90.0.2-3mdk
- enable 64-bit targets for ppc and sparc

* Thu May 05 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.16.90.0.2-2mdk
- selected fix from CVS to fix kdebase build:
  * skip weak definitions if a strong definition has already been seen

* Sun May 01 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.16.90.0.2-1mdk
- 2.16.90.0.2
- fix ld -pie

* Wed Apr 27 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.16.90.0.1-2mdk
- Selected fixes from mainline CVS to fix --as-needed and PR ld/815

* Tue Apr 26 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.16.90.0.1-1mdk
- 2.16.90.0.1

* Tue Mar 08 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.15.92.0.2-6mdk
- don't build shared libraries for cross binutils

* Tue Feb 01 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.15.92.0.2-5mdk
- handle protected functions correctly on x86_64 (PR binutils/584, H. J. Lu)

* Tue Jan 18 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.15.92.0.2-4mdk
- make "as" aware of its current personality on x86-64 so that 32-bit
  object can be generated by default (if running under linux32)

* Thu Dec 16 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.15.92.0.2-3mdk
- fix build on x86_64

* Wed Nov 24 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.15.92.0.2-2mdk
- Further merge with RH 2.15.92.0.2-6
  * revert Sep 09 change to make ppc L second argument e.g. for tlbie non-optional
  * fix --just-symbols on ppc64 (Alan Modra, #135498)
  * fix -pie on ppc64

* Wed Nov 10 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.15.92.0.2-1mdk
- Merge with RH 2.15.92.0.2-6
  * fix ar xo
  * fix stripping of prelinked binaries and libraries
  * allow strings(1) on 32-bit arches to be used again with > 2GB files
  * fix code detecting matching linkonce and single member comdat group sections
  * fix -z relro to make sure end of PT_GNU_RELRO segment is always COMMONPAGESIZE aligned
  * fix orphan section placement
  * change ld's ld.so.conf parser to match ldconfig's

* Wed May 12 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.15.90.0.3-1mdk
- 2.15.90.0.3
- change x86-64 .plt symbol st_size handling to match ia32 (RH 2.15.90.0.3-4)

* Mon Jan 12 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.14.90.0.7-2mdk
- Fix cross binutils builds with newer rpm
- Enable Mach-O and PEF targets on cross PowerPC binutils

